package projectzombie.items;

import gl_engine.MathHelpers;
import gl_engine.vec.Vec2d;
import gl_engine.vec.Vec2i;
import gl_engine.vec.Vec3d;
import projectzombie.entity.player.EntityPlayer;
import projectzombie.init.Models;
import projectzombie.init.Tiles;
import projectzombie.model.Model;
import projectzombie.model.ModelItem;
import projectzombie.util.ItemStack;
import projectzombie.world.chunk.Chunk;
import projectzombie.world.layer.Layer;

public class ItemLantern extends Item
{

	@Override
	public ModelItem getModel(ItemStack stack) {
		return Models.ITEM_LANTERN;
	}
	
	@Override
	public double getLightLevel(ItemStack stack) {
		return 1;
	}
	
	@Override
	public Model getPlaceModel(ItemStack stack) {
		return Models.TILE_LANTERN;
	}
	
	@Override
	public boolean onPlayerRightClick(ItemStack stack, Layer layer, EntityPlayer player, Vec2d place_pos)
	{
		Vec2i pos = place_pos.toInt();
		
		if(layer.getFrontTile(pos).tile == Tiles.VOID) {
			layer.setFrontTile(Tiles.LANTERN.getDefaultState(), pos);
			stack.count -= 1;
			return true;
		}
		
		return false;
	}
	
	@Override
	public String getName(ItemStack stack) {
		return "Lantern";
	}

}
